

-- UPDATE 7/fix_db_20140319.sql

update species_table set hypothetical=false where hypothetical is null;

-- UPDATE 7/fix_db_20140430.sql

ALTER TABLE model_table
   ADD COLUMN idmodel character varying;

ALTER TABLE model_table
   ADD COLUMN metaid character varying;
  
create table history_table (
	iddb serial,
	query varchar,
	map varchar,
	timestamp timestamp without time zone,
	type integer,
	ipaddress varchar
);

-- UPDATE 7/fix_db_20140516.sql

-- change cache query

ALTER TABLE cachequery ADD COLUMN type integer;

update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeCandidateSet';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeCatalystActivity';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeComplex';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeDatabaseObject';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeEntitySet';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeEntityWithAccessionedSequence';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeEvent';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeLiteratureReference';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomePhysicalEntity';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeReactionlikeEvent';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeReferenceMolecule';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeReferenceSequence';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeSimpleEntity';
update cachequery set type =0 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.reactome.model.ReactomeStableIdentifier';
update cachequery set type =1 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.utils.annotation.AnnotationRestService';
update cachequery set type =2 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.utils.annotation.ChEMBLParser';
update cachequery set type =3 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.utils.annotation.data.Article';
update cachequery set type =4 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.utils.annotation.DrugbankHTMLParser';
update cachequery set type =5 where substring (query from 0 for position(chr(10) in query)) = 'lcsb.mapviewer.utils.annotation.IdConverter';

ALTER TABLE cachequery ALTER COLUMN type set not null;

update cachequery set query= substring(query from position(chr(10) in query)+1)  where position(chr(10) in query)>0;

ALTER TABLE cachequery ADD COLUMN expires timestamp without time zone;

update cachequery set expires = accessed + interval '42 days';

-- and now entry

ALTER TABLE cacheentry ADD COLUMN type integer;

update cacheentry set type =0;

ALTER TABLE cacheentry ALTER COLUMN type set not null;

ALTER TABLE cacheentry ADD COLUMN expires timestamp without time zone;

update cacheentry set expires = accessed + interval '42 days';

ALTER TABLE cacheentry ADD COLUMN customid integer;
update cacheentry set customid = iddb;

-- set auto increment id
CREATE SEQUENCE cacheentry_iddb_seq  INCREMENT 1  MINVALUE 1  MAXVALUE 9223372036854775807  START 1  CACHE 1;
delete from cacheentry;
ALTER TABLE cacheentry ALTER COLUMN iddb SET DEFAULT nextval('cacheentry_iddb_seq'::regclass);

--recreate search index
drop index query_index;
CREATE INDEX query_index
  ON cachequery
  USING btree
  (type, query COLLATE pg_catalog."default");


-- UPDATE 7/fix_db_20140602.sql

ALTER TABLE layout ADD COLUMN creator_iddb integer;
ALTER TABLE layout ADD COLUMN publiclayout boolean;
update layout set publiclayout=true;


-- UPDATE 7/fix_db_20140603.sql

alter table alias_table drop column maxvisibilitylevel;
alter table alias_table drop column minvisibilitylevel;

alter table alias_table add column transparencyLevel numeric;
update alias_table set transparencyLevel=0;

-- UPDATE 7/fix_db_20140605.sql

CREATE TABLE configuration_table (
    iddb integer NOT NULL,
    type integer,
    value character varying(255)
);

CREATE SEQUENCE configuration_table_iddb_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;

ALTER SEQUENCE configuration_table_iddb_seq OWNED BY configuration_table.iddb;

ALTER TABLE ONLY configuration_table ALTER COLUMN iddb SET DEFAULT nextval('configuration_table_iddb_seq'::regclass);

ALTER TABLE ONLY configuration_table
    ADD CONSTRAINT configuration_table_pkey PRIMARY KEY (iddb);


-- UPDATE 7/fix_db_20140606.sql

alter table layout add column progress double precision;
alter table layout add column status integer;

update layout set progress =0.0, status =0;

-- UPDATE 7/fix_db_20140612.sql

alter table species_table add column fullname varchar(255);
alter table species_table add column symbol varchar(255);

drop table if exists element_synonyms;
create table element_synonyms (
	iddb integer,
	idx integer,
	synonym varchar(255),

	CONSTRAINT element_synonyms_pkey PRIMARY KEY (iddb, idx),
	CONSTRAINT element_synonyms_fkey FOREIGN KEY (iddb)
      REFERENCES species_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION

);

drop table if exists element_former_symbols;
create table element_former_symbols (
	iddb integer,
	idx integer,
	symbol varchar(255),

	CONSTRAINT element_former_symbols_pkey PRIMARY KEY (iddb, idx),
	CONSTRAINT element_former_symbols_fkey FOREIGN KEY (iddb)
      REFERENCES species_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION

);

alter table species_table add column smiles text;
alter table species_table add column inchi text;
alter table species_table add column inchikey varchar(255);

CREATE SEQUENCE associated_phenotype_element_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
 CREATE TABLE associated_phenotype_element_table
(
  iddb integer NOT NULL DEFAULT nextval('associated_phenotype_element_table_iddb_seq'::regclass),
  source integer,
  data_iddb integer,
  phenotype_iddb integer,
  CONSTRAINT associated_phenotype_element_table_pkey PRIMARY KEY (iddb),
  CONSTRAINT associated_phenotype_element_table_fk FOREIGN KEY (data_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT associated_phenotype_element_table_fk2 FOREIGN KEY (phenotype_iddb)
      REFERENCES species_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);


-- UPDATE 7/fix_db_20140616.sql

alter table model_table alter shortdescription type text;
alter table model_table alter notes type text;

delete from cachequery where type =7 and query like 'id:%';

-- UPDATE 7/fix_db_20140702.sql

alter table model_table add column notifyemail varchar(255);
alter table layout add column description text;


-- UPDATE 7/fix_db_20140718.sql

update alias_table set  alias_type_db='Artificial Compartment Alias' WHERE alias_type_db='Artifitial Compartment Alias';

-- UPDATE 7/fix_db_20140904.sql

update node_table set reaction_iddb=parent_iddb where reaction_iddb is null;
alter table node_table drop column parent_iddb;

-- UPDATE 7/fix_db_20140909.sql

alter table layout add column hierarchicalview boolean default false;

-- UPDATE 7/fix_db_20141007.sql

CREATE SEQUENCE cache_type_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 10
  CACHE 1;
  
 CREATE TABLE cache_type
(
  iddb integer NOT NULL DEFAULT nextval('cache_type_iddb_seq'::regclass),
  validity integer,
  classname varchar,
  CONSTRAINT cache_type_pkey PRIMARY KEY (iddb)
);

INSERT INTO cache_type VALUES (1, 28, 'lcsb.mapviewer.reactome.utils.ReactomeConnector');
INSERT INTO cache_type VALUES (2, 28, 'lcsb.mapviewer.annotation.services.AnnotationRestService');
INSERT INTO cache_type VALUES (3, 28, 'lcsb.mapviewer.annotation.services.ChEMBLParser');
INSERT INTO cache_type VALUES (4, 365, 'lcsb.mapviewer.annotation.services.PubmedParser');
INSERT INTO cache_type VALUES (5, 28, 'lcsb.mapviewer.annotation.services.DrugbankHTMLParser');
INSERT INTO cache_type VALUES (6, 28, 'lcsb.mapviewer.annotation.services.IdConverter');
INSERT INTO cache_type VALUES (7, -1, 'lcsb.mapviewer.annotation.cache.MockCacheInterface');
INSERT INTO cache_type VALUES (8, 28, 'lcsb.mapviewer.annotation.services.ChebiBackend');
INSERT INTO cache_type VALUES (9, 28, 'lcsb.mapviewer.annotation.services.GoBackend');



-- UPDATE 7/fix_db_20141009.sql

--fix rna regions
CREATE SEQUENCE rna_region_table_idrnaregiondb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

  CREATE TABLE rna_region_table
(
  iddb integer NOT NULL,
  idrnaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  type character varying(255),
  state character varying(255),
  idspeciesdb integer,
  CONSTRAINT rna_region_table_pkey PRIMARY KEY (iddb),
  CONSTRAINT rna_region_species_iddb_fk FOREIGN KEY (idspeciesdb)
      REFERENCES species_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

ALTER TABLE rna_region_table
ALTER COLUMN iddb set DEFAULT nextval('rna_region_table_idrnaregiondb_seq'::regclass);

--and now antisense rna regions
ALTER TABLE antisense_rna_region_table
ALTER COLUMN idantisensernaregiondb set DEFAULT nextval('antisense_rna_region_table_idrnaregiondb_seq'::regclass);

-- UPDATE 7/fix_db_20141013.sql

ALTER TABLE model_table
   ADD COLUMN creationwarnings text;


-- UPDATE 7/fix_db_20141015.sql

-- fix state in protein modifications
alter table modification_residue_table ADD COLUMN state_int integer;

update  modification_residue_table set state_int = 0 where state='phosphorylated';
update  modification_residue_table set state_int = 1 where state='acetylated';
update  modification_residue_table set state_int = 2 where state='ubiquitinated';
update  modification_residue_table set state_int = 3 where state='methylated';
update  modification_residue_table set state_int = 4 where state='hydroxylated';
update  modification_residue_table set state_int = 5 where state='myristoylated';
update  modification_residue_table set state_int = 6 where state='sulfated';
update  modification_residue_table set state_int = 7 where state='prenylated';
update  modification_residue_table set state_int = 8 where state='glycosylated';
update  modification_residue_table set state_int = 9 where state='palmytoylated';
update  modification_residue_table set state_int = 10 where state='unknown';
update  modification_residue_table set state_int = 11 where state='protonated';
update  modification_residue_table set state_int = 12 where state='don''t care';

alter table modification_residue_table drop column state;
alter table modification_residue_table rename state_int to state;

-- fix state in rna regions
alter table rna_region_table ADD COLUMN state_int integer;

update  rna_region_table set state_int = 0 where state='phosphorylated';
update  rna_region_table set state_int = 1 where state='acetylated';
update  rna_region_table set state_int = 2 where state='ubiquitinated';
update  rna_region_table set state_int = 3 where state='methylated';
update  rna_region_table set state_int = 4 where state='hydroxylated';
update  rna_region_table set state_int = 5 where state='myristoylated';
update  rna_region_table set state_int = 6 where state='sulfated';
update  rna_region_table set state_int = 7 where state='prenylated';
update  rna_region_table set state_int = 8 where state='glycosylated';
update  rna_region_table set state_int = 9 where state='palmytoylated';
update  rna_region_table set state_int = 10 where state='unknown';
update  rna_region_table set state_int = 11 where state='protonated';
update  rna_region_table set state_int = 12 where state='don''t care';

alter table rna_region_table drop column state;
alter table rna_region_table rename state_int to state;

-- fix state in antisense rna regions
alter table antisense_rna_region_table ADD COLUMN state_int integer;

update  antisense_rna_region_table set state_int = 0 where state='phosphorylated';
update  antisense_rna_region_table set state_int = 1 where state='acetylated';
update  antisense_rna_region_table set state_int = 2 where state='ubiquitinated';
update  antisense_rna_region_table set state_int = 3 where state='methylated';
update  antisense_rna_region_table set state_int = 4 where state='hydroxylated';
update  antisense_rna_region_table set state_int = 5 where state='myristoylated';
update  antisense_rna_region_table set state_int = 6 where state='sulfated';
update  antisense_rna_region_table set state_int = 7 where state='prenylated';
update  antisense_rna_region_table set state_int = 8 where state='glycosylated';
update  antisense_rna_region_table set state_int = 9 where state='palmytoylated';
update  antisense_rna_region_table set state_int = 10 where state='unknown';
update  antisense_rna_region_table set state_int = 11 where state='protonated';
update  antisense_rna_region_table set state_int = 12 where state='don''t care';

alter table antisense_rna_region_table drop column state;
alter table antisense_rna_region_table rename state_int to state;

--change names in antisense rna regions identifiers
alter table antisense_rna_region_table rename idAntisenseRnaRegionDb to iddb;
alter table antisense_rna_region_table rename id to idantisensernaregion;

--change primary key in antisense rna region and drop unnecessary objects
alter table antisense_rna_region_table drop CONSTRAINT  antisense_rna_region_table_pkey;
alter table antisense_rna_region_table add CONSTRAINT antisense_rna_region_table_pkey PRIMARY KEY (iddb);

alter table antisense_rna_region_table alter column idrnaregiondb set default null;
alter table antisense_rna_region_table drop constraint antisense_rna_region_table_idantisensernaregiondb_key;
alter table antisense_rna_region_table drop constraint fkc75381701e595a8a;
alter table antisense_rna_region_table drop constraint fkc7538170a4c0d273;

CREATE SEQUENCE antisense_rna_region_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 10
  CACHE 1;

select setval('antisense_rna_region_table_iddb_seq', nextval('antisense_rna_region_table_idrnaregiondb_seq'));

ALTER TABLE antisense_rna_region_table
ALTER COLUMN iddb set DEFAULT nextval('antisense_rna_region_table_iddb_seq'::regclass);


alter table antisense_rna_region_table drop column idrnaregiondb;
drop  sequence if exists antisense_rna_region_table_idrnaregiondb_seq;


-- UPDATE 7/fix_db_20141016.sql

-- fix type in antisense rna region
alter table antisense_rna_region_table ADD COLUMN type_int integer;

update  antisense_rna_region_table set type_int = 0 where type='Modification Site';
update  antisense_rna_region_table set type_int = 1 where type='CodingRegion';
update  antisense_rna_region_table set type_int = 2 where type='proteinBindingDomain';

alter table antisense_rna_region_table drop column type;
alter table antisense_rna_region_table rename type_int to type;

--change names in modification residue db identifiers
alter table modification_residue_table rename idModificationResidueDb to iddb;
alter table modification_residue_table rename id to idModificationResidue;


-- UPDATE 7/fix_db_20141024.sql

-- fix comments table
update feedback set tablename='lcsb.mapviewer.model.map.reaction.type.StateTransitionReaction' where tablename='lcsb.mapviewer.db.model.map.reaction.type.StateTransitionReaction';
update feedback set tablename='lcsb.mapviewer.model.map.reaction.type.TransportReaction' where tablename='lcsb.mapviewer.db.model.map.reaction.type.TransportReaction';
update feedback set tablename='lcsb.mapviewer.model.map.layout.alias.SpeciesAlias' where tablename='lcsb.mapviewer.db.model.map.layout.alias.SpeciesAlias';
update feedback set tablename='lcsb.mapviewer.model.map.reaction.type.UnknownTransitionReaction' where tablename='lcsb.mapviewer.db.model.map.reaction.type.UnknownTransitionReaction';


-- UPDATE 7/fix_db_20141027.sql

--fix cache
update cache_type set iddb = 0 where classname='lcsb.mapviewer.reactome.utils.ReactomeConnector';
update cache_type set iddb = 1 where classname='lcsb.mapviewer.annotation.services.AnnotationRestService';
update cache_type set iddb = 2 where classname='lcsb.mapviewer.annotation.services.ChEMBLParser';
update cache_type set iddb = 3 where classname='lcsb.mapviewer.annotation.services.PubmedBackend';
update cache_type set iddb = 4 where classname='lcsb.mapviewer.annotation.services.DrugbankHTMLParser';
update cache_type set iddb = 5 where classname='lcsb.mapviewer.annotation.services.IdConverter';
update cache_type set iddb = 6 where classname='lcsb.mapviewer.annotation.cache.MockCacheInterface';
update cache_type set iddb = 7 where classname='lcsb.mapviewer.annotation.services.ChebiBackend';
update cache_type set iddb = 8 where classname='lcsb.mapviewer.annotation.services.GoBackend';


-- UPDATE 7/fix_db_20141106.sql

-- removing cacheentry
drop table cacheentry;
drop sequence cacheentry_iddb_seq;

-- merging feedback and comments
alter table feedback drop column feedback_type;

-- species alias and compartment alias contain common element
alter table alias_table ADD COLUMN idelementdb integer;
update alias_table set idelementdb=idspeciesdb where idspeciesdb is not null;
update alias_table set idelementdb=idcompartmentdb where idcompartmentdb is not null;

ALTER TABLE alias_table DROP CONSTRAINT fk1220391f1e595a8a;
ALTER TABLE alias_table DROP CONSTRAINT fk1220391f5720a4be;

ALTER TABLE alias_table
  ADD CONSTRAINT fkalias_element FOREIGN KEY (idelementdb)
      REFERENCES species_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

alter table alias_table drop COLUMN idspeciesdb;
alter table alias_table drop COLUMN idcompartmentdb;

--rename column name in miriam data

alter table miriam_data_table rename species_iddb to element_iddb;
 

-- UPDATE 7/fix_db_20141107.sql

update species_table set species_type_db = 'GENERIC_PROTEIN' where species_type_db='Protein' and type='GENERIC';
update species_table set species_type_db = 'ION_CHANNEL_PROTEIN' where species_type_db='Protein' and type='ION_CHANNEL';
update species_table set species_type_db = 'TRUNCATED_PROTEIN' where species_type_db='Protein' and type='TRUNCATED';
update species_table set species_type_db = 'RECEPTOR_PROTEIN' where species_type_db='Protein' and type='RECEPTOR';


-- UPDATE 7/fix_db_20141112.sql

--simplify model by removing CD specific identifiers
alter table species_table drop column antisensernaid;
alter table species_table drop column degradedid;
alter table species_table drop column drugid; 
alter table species_table drop column geneid; 
alter table species_table drop column ionid;
alter table species_table drop column phenotypeid;
alter table species_table drop column idprotein; 
alter table species_table drop column rnaid;
alter table species_table drop column simplemoleculeid;
alter table species_table drop column unknownid;

-- UPDATE 7/fix_db_20141113.sql

-- structure of drug changed, so we need to remove cached values
delete from cachequery where (type =2 or type =4) and query like 'drug:%';
delete from cachequery where (type =2 or type =4) and query like 'name:%';
insert into cache_type(iddb, validity, classname) values (9, 365, 'lcsb.mapviewer.annotation.services.MiriamConnector');


-- UPDATE 7/fix_db_20141114.sql

--refactorization of miriam data
alter table miriam_data_table add column datatype varchar(255);
update miriam_data_table set datatype = 'CAS' where datatypeuri='urn:miriam:cas';
update miriam_data_table set datatype = 'CHEBI' where datatypeuri='urn:miriam:obo.chebi';
update miriam_data_table set datatype = 'CHEBI' where datatypeuri='urn:miriam:chebi';
update miriam_data_table set datatype = 'CHEMBL_COMPOUND' where datatypeuri='urn:miriam:chembl.compound';
update miriam_data_table set datatype = 'CHEMBL_TARGET' where datatypeuri='urn:miriam:chembl.target';
update miriam_data_table set datatype = 'EC' where datatypeuri='urn:miriam:ec-code';
update miriam_data_table set datatype = 'EC' where datatypeuri='urn:miriam:enzyme.nomenclature';
update miriam_data_table set datatype = 'ENSEMBL' where datatypeuri='urn:miriam:ensembl';
update miriam_data_table set datatype = 'ENTREZ' where datatypeuri='urn:miriam:ncbigene';
update miriam_data_table set datatype = 'ENTREZ' where datatypeuri='urn:miriam:entrez.gene';
update miriam_data_table set datatype = 'GO' where datatypeuri='urn:miriam:obo.go';
update miriam_data_table set datatype = 'GO' where datatypeuri='urn:miriam:go';
update miriam_data_table set datatype = 'HGNC' where datatypeuri='urn:miriam:hgnc';
update miriam_data_table set datatype = 'HGNC_SYMBOL' where datatypeuri='urn:miriam:hgnc.symbol';
update miriam_data_table set datatype = 'HMDB' where datatypeuri='urn:miriam:hmdb';
update miriam_data_table set datatype = 'INTERPRO' where datatypeuri='urn:miriam:interpro';
update miriam_data_table set datatype = 'KEGG_COMPOUND' where datatypeuri='urn:miriam:kegg.compound';
update miriam_data_table set datatype = 'KEGG_GENES' where datatypeuri='urn:miriam:kegg.genes:hsa';
update miriam_data_table set datatype = 'KEGG_GENES' where datatypeuri='urn:miriam:kegg.genes';
update miriam_data_table set datatype = 'KEGG_PATHWAY' where datatypeuri='urn:miriam:kegg.pathway';
update miriam_data_table set datatype = 'KEGG_REACTION' where datatypeuri='urn:miriam:kegg.reaction';
update miriam_data_table set datatype = 'MESH_2012' where datatypeuri='urn:miriam:mesh';
update miriam_data_table set datatype = 'MESH_2012' where datatypeuri='urn:miriam:mesh.2012';
update miriam_data_table set datatype = 'MGD' where datatypeuri='urn:miriam:mgd';
update miriam_data_table set datatype = 'PANTHER' where datatypeuri like 'urn:miriam:panther.family%';
update miriam_data_table set datatype = 'PANTHER' where datatypeuri='urn:miriam:panther';
update miriam_data_table set datatype = 'PHARM' where datatypeuri='urn:miriam:pharmgkb.pathways';
update miriam_data_table set datatype = 'PUBCHEM' where datatypeuri='urn:miriam:pubchem.compound';
update miriam_data_table set datatype = 'PUBCHEM_SUBSTANCE' where datatypeuri='urn:miriam:pubchem.substance';
update miriam_data_table set datatype = 'PUBMED' where datatypeuri='urn:miriam:pubmed';
update miriam_data_table set datatype = 'REACTOME' where datatypeuri='urn:miriam:reactome';
update miriam_data_table set datatype = 'REFSEQ' where datatypeuri='urn:miriam:refseq';
update miriam_data_table set datatype = 'UNIPROT' where datatypeuri='urn:miriam:uniprot';
update miriam_data_table set datatype = 'WIKIPATHWAYS' where datatypeuri='urn:miriam:wikipathways';
update miriam_data_table set datatype = 'WIKIPEDIA' where datatypeuri='urn:miriam:wikipedia.en';
update miriam_data_table set datatype = 'UNKNOWN' where datatypeuri='urn:miriam:bind';
alter table miriam_data_table drop column datatypeuri;


-- UPDATE 7/fix_db_20141117.sql

--modification of MiriamData
alter table miriam_data_table add column reltype integer;
update miriam_data_table set reltype=0 where relationtype='bqmodel:is';
update miriam_data_table set reltype=1 where relationtype='bqmodel:isDescribedBy';
update miriam_data_table set reltype=2 where relationtype='bqbiol:is';
update miriam_data_table set reltype=3 where relationtype='bqbiol:hasPart';
update miriam_data_table set reltype=4 where relationtype='bqbiol:isPartOf';
update miriam_data_table set reltype=5 where relationtype='bqbiol:isVersionOf';
update miriam_data_table set reltype=6 where relationtype='bqbiol:hasVersion';
update miriam_data_table set reltype=7 where relationtype='bqbiol:isHomologTo';
update miriam_data_table set reltype=8 where relationtype='bqbiol:isDescribedBy';
update miriam_data_table set reltype=9 where relationtype='bqbiol:isEncodedBy';
update miriam_data_table set reltype=10 where relationtype='bqbiol:encodes';
update miriam_data_table set reltype=11 where relationtype='bqbiol:occures';
alter table miriam_data_table drop column relationtype;
alter table miriam_data_table rename column reltype to relationtype;

--clearing drugs (modification in Drug structure)
delete from cachequery where (type =2 or type =4) and query like 'drug:%';
delete from cachequery where (type =2 or type =4) and query like 'name:%';

alter table reaction_table drop column type;


-- UPDATE 7/fix_db_20141118.sql

--clear go cache
delete from cachequery where type = 8;

-- UPDATE 7/fix_db_20141119.sql

-- modification on model table
alter table model_table drop column shortdescription;

-- clearing data mining information (required for structure change in data mining)
delete from references_table;
delete from missingconnection;

-- modifing data_mining structure
ALTER TABLE references_table
  drop CONSTRAINT fkdfe14357f943f5d4;

ALTER TABLE references_table ADD COLUMN idx integer;
ALTER TABLE references_table ALTER COLUMN idx SET NOT NULL;

ALTER TABLE references_table DROP COLUMN reference;
ALTER TABLE references_table DROP COLUMN reference_id;

ALTER TABLE references_table ADD COLUMN missingconnection_iddb integer;
ALTER TABLE references_table ALTER COLUMN missingconnection_iddb SET NOT NULL;
ALTER TABLE references_table ADD COLUMN miriam_iddb integer;
ALTER TABLE references_table ALTER COLUMN miriam_iddb SET NOT NULL;

ALTER TABLE references_table
  ADD CONSTRAINT references_table_miriam_pkey PRIMARY KEY(missingconnection_iddb, idx);
ALTER TABLE references_table
  ADD CONSTRAINT references_table_foreign_key FOREIGN KEY (missingconnection_iddb)
      REFERENCES missingconnection (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE references_table
  ADD CONSTRAINT references_table_foreign_miriam_key FOREIGN KEY (miriam_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE references_table
  ADD CONSTRAINT references_table_unique_miriam UNIQUE(miriam_iddb);

alter table references_table rename to missingconnection_miriam_data_table;
alter table missingconnection_miriam_data_table rename column miriam_iddb to  references_iddb;


-- UPDATE 7/fix_db_20141124.sql

--Venkata changed response from the server
delete from cachequery where type = 1;

-- map path functionality removed
drop table mappathnode;
drop table mappath;

--taxonomy service
insert into cache_type (iddb,validity,classname) values (10,365,'lcsb.mapviewer.annotation.services.TaxonomyBackend');

-- UPDATE 7/fix_db_20141125.sql

--change in drug structure
delete from cachequery where query like 'drug%' or query like 'name%';
--project doesn't contain visible column anymore
alter table project_table drop column visible;

-- UPDATE 7/fix_db_20141126.sql

--remove of layerline class
alter table layer_table_layerline rename to layer_table_polylinedata;
alter table layer_table_polylinedata drop CONSTRAINT fkcbfabea6573d6d60;
alter table layer_table_polylinedata add CONSTRAINT fkcbfabea6573d6d60 FOREIGN KEY (lines_iddb)
      REFERENCES polylinedata (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
drop table layerline;

--change in data mining interface

alter table missingconnection rename to datamining;
alter table missingconnection_miriam_data_table rename to datamining_miriam_data_table;
alter table datamining drop column name;
alter table datamining drop column link;
alter table datamining drop column score;
delete from datamining_miriam_data_table;
delete from datamining;
alter table datamining drop CONSTRAINT fkeecb14c4be8a7411;
alter table datamining add CONSTRAINT fkeecb14c4be8a7411 FOREIGN KEY (element_iddb)
      REFERENCES species_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
alter table datamining_miriam_data_table rename column missingconnection_iddb to datamining_iddb;
CREATE TABLE datamining_suggested_connections
(
  idx integer NOT NULL,
  datamining_iddb integer NOT NULL,
  suggestedconnections_iddb integer NOT NULL,
  CONSTRAINT datamining_suggested_connections_table_miriam_pkey PRIMARY KEY (datamining_iddb, idx),
  CONSTRAINT datamining_suggested_connections_table_foreign_key FOREIGN KEY (datamining_iddb)
      REFERENCES datamining (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_suggested_connections_table_foreign_miriam_key FOREIGN KEY (suggestedconnections_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_suggested_connections_table_unique_miriam UNIQUE (suggestedconnections_iddb)
  );  
drop table unified_node_elements;
drop table unifiednode;

-- UPDATE 7/fix_db_20141127.sql

--postion to compartment changed into enum
update species_table set positiontocompartment='INSIDE' where positiontocompartment = 'inside';
update species_table set positiontocompartment='INSIDE_OF_MEMBRANE' where positiontocompartment = 'insideOfMembrane';
update species_table set positiontocompartment='TRANSMEMBRANE' where positiontocompartment = 'transmembrane';
update species_table set positiontocompartment='OUTER_SURFACE' where positiontocompartment = 'outerSurface';
update species_table set positiontocompartment='INNER_SURFACE' where positiontocompartment = 'innerSurface';


-- UPDATE 7/fix_db_20141202.sql

DROP INDEX query_index;
CREATE INDEX query_index
  ON cachequery
  USING hash
  (query COLLATE pg_catalog."default");


-- UPDATE 7/fix_db_20141212.sql

alter table user_table add column removed boolean default false;

-- UPDATE 7/fix_db_20141218.sql

alter table project_table add column errors text;

-- UPDATE 7/fix_db_20150107.sql

-- create submodel connection table 
create table submodel_connection_table
(
	submodel_connections_type_db character varying(31) NOT NULL,
	iddb serial NOT NULL,
	name character varying(255),
	submodel_iddb integer,
	type character varying(31) NOT NULL,
	parentmodel_iddb integer,
	fromalias_iddb integer,
	toalias_iddb integer,
	CONSTRAINT submodel_connection_table_pkey PRIMARY KEY (iddb),
	CONSTRAINT fk_submodel_connection_model FOREIGN KEY (submodel_iddb)
      REFERENCES model_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
	CONSTRAINT fk_parent_model_connection_model FOREIGN KEY (parentmodel_iddb)
      REFERENCES model_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
	CONSTRAINT fk_submodel_connection_from_alias FOREIGN KEY (fromalias_iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
	CONSTRAINT fk_submodel_connection_to_alias FOREIGN KEY (toalias_iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- create submodel connection in alias table
alter table alias_table add column submodel_iddb integer;
-- add foreign key
alter table alias_table add constraint fk_alias_submodel FOREIGN KEY (submodel_iddb)
    REFERENCES submodel_connection_table (iddb) MATCH SIMPLE
    ON UPDATE NO ACTION ON DELETE NO ACTION;
   
-- modify data in log table due to reorganization of model package structure
update log_table set tablename='lcsb.mapviewer.model.map.model.ModelFullIndexed' where tablename like 'lcsb.mapviewer.model.map.ModelFullIndexed';


-- UPDATE 7/fix_db_20150108.sql

alter table model_table add column name character varying(255);

-- UPDATE 7/fix_db_20150109.sql

alter table model_table alter column project_iddb drop not null;
alter table submodel_connection_table drop column type;
alter table submodel_connection_table add column type integer;
update submodel_connection_table set type = 0;
alter table submodel_connection_table alter column type set not null;


-- UPDATE 7/fix_db_20150120.sql

alter table layout add column layout_iddb integer;
alter table layout add constraint layout_layout_fk FOREIGN KEY (layout_iddb) REFERENCES layout (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
alter table layout rename column layout_iddb to parentlayout_iddb;

-- UPDATE 7/fix_db_20150310.sql

alter table feedback add column submodel_iddb integer;
alter table feedback add constraint fk_feedback_submodel foreign key (submodel_iddb) references model_table (iddb) match simple;
update feedback set submodel_iddb=model_iddb ;

-- UPDATE 7/fix_db_20150316.sql

--modification of tables for recon annotations
--elements
alter table species_table add column abbreviation character varying(255);
alter table species_table add column formula character varying(255);

--reactions
alter table reaction_table add column symbol character varying(255);
alter table reaction_table add column abbreviation character varying(255);
alter table reaction_table add column formula character varying(255);
alter table reaction_table add column subsystem character varying(255);
alter table reaction_table add column geneproteinreaction character varying(255);
alter table reaction_table add column mechanicalconfidencescore integer;
alter table reaction_table add column upperbound double precision;
alter table reaction_table add column lowerbound double precision;

--and synonyms in the reaction table
CREATE TABLE reaction_synonyms
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  synonym character varying(255),
  CONSTRAINT reaction_synonyms_pkey PRIMARY KEY (iddb, idx),
  CONSTRAINT reaction_synonyms_fkey FOREIGN KEY (iddb)
      REFERENCES reaction_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);



-- UPDATE 7/fix_db_20150324.sql

-- table for external projects
CREATE TABLE external_project
(
  iddb serial NOT NULL,
  name varchar(255),
  CONSTRAINT external_project_pkey PRIMARY KEY (iddb)
);

-- table for external users
CREATE TABLE external_user
(
  iddb serial NOT NULL,
  name varchar(255) not null,
  surname varchar(255) not null,
  email varchar(255),
  CONSTRAINT external_user_pkey PRIMARY KEY (iddb)
);

-- framework version (past and current)
CREATE TABLE framework_version
(
  iddb serial NOT NULL,
  version integer not null unique,
  "time" timestamp without time zone not null,
  svnVersion integer not null,
  description character varying(255),
  CONSTRAINT framework_version_pkey PRIMARY KEY (iddb)
);

-- changelog information
CREATE TABLE changelog
(
  iddb serial NOT NULL,
  svnVersion integer not null,
  description character varying(255) not null,
  type character varying(255) not null,
  requestproject_iddb integer,
  requestuser_iddb integer,
  CONSTRAINT changelog_pkey PRIMARY KEY (iddb),
  CONSTRAINT changelog_requestuser_fk FOREIGN KEY (requestuser_iddb)
      REFERENCES external_user (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT changelog_requestproject_fk FOREIGN KEY (requestproject_iddb)
      REFERENCES external_project (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- add framework versions available until now
insert into framework_version(version,"time", svnversion) values (1, timestamp'2013-12-04',54);
insert into framework_version(version,"time", svnversion) values (2, timestamp'2014-02-02',66);
insert into framework_version(version,"time", svnversion) values (3, timestamp'2014-06-05',117);
insert into framework_version(version,"time", svnversion) values (4, timestamp'2014-09-11',186);
insert into framework_version(version,"time", svnversion) values (5, timestamp'2014-12-18',369);

-- add projects
insert into external_project (name) values ('Parkinson''s Disease map');
insert into external_project (name) values ('RECON');

-- add people
insert into external_user (name, surname, email) values ('Piotr', 'Gawron', 'piotr.gawron@uni.lu');
insert into external_user (name, surname, email) values ('Marek', 'Ostaszewski', 'marek.ostaszewski@uni.lu');
insert into external_user (name, surname, email) values ('Stephan', 'Gebel', 'stephan.gebel@uni.lu');
insert into external_user (name, surname, email) values ('Ronan', 'Fleming', 'ronan.mt.fleming@gmail.com');


-- changlog information
delete from changelog;
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (57, 'Problem with touch interface after update of browsers engine', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (59, 'Problem in Safari when searching for elements', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (66, 'Upload of the CellDesigner map', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (78, 'Drug targeting', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (93, 'Export to CellDesigner', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (109, 'Status page of all dependent services', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (117, 'Cache interface for data from external services', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (117, 'Configuration page', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (121, 'Custom layout upload', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (126, 'Additional structural information imported from annotation service', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (127, 'Fonts and lines in hierarchical view', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (131, 'Import data from GO', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (131, 'Export problem', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (134, 'Problem with users and session expire', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (134, 'Problem with special UTF-8 characters in CellDesigner file', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (134, 'Problem with touching bubbles on touch interface', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (135, 'Visualization of residues in rna, antisense rna, proteins', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (135, 'Export of the part of the map into CellDesigner file', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (155, 'Logo files managable via config webpage', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (160, 'Autoresfresh of cached data', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (216, 'Problem with touch interface on Windows 8.1', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (216, 'Google Maps API problem with floating bubbles', 'BUG_FIX', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (218, 'Parsing and annotation warnings for models in admin panel', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (222, 'Right click on Windows 8.1 touch interface', 'FUNCTIONALITY', null, null);
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (256, 'Information about build', 'FUNCTIONALITY', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (272, 'Error handling in admin panel', 'BUG_FIX', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (327, 'Popup window in admin panel that list warnings', 'FUNCTIONALITY', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (328, 'Additional checkboxes in upload model: annotate automatically, cache data, verify annotations', 'FUNCTIONALITY', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (329, 'Reaction color in CellDesigner file', 'BUG_FIX', (select iddb from external_project where name ='RECON'), (select iddb from external_user where email ='ronan.mt.fleming@gmail.com'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (330, 'Reaction line width', 'BUG_FIX', (select iddb from external_project where name ='RECON'), (select iddb from external_user where email ='ronan.mt.fleming@gmail.com'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (331, 'Custom reaction visualization in upload layout', 'FUNCTIONALITY', (select iddb from external_project where name ='RECON'), (select iddb from external_user where email ='ronan.mt.fleming@gmail.com'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (373, 'Errors from parsing data forwarded to client', 'FUNCTIONALITY', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (374, 'Notification email system added', 'FUNCTIONALITY', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (375, 'Warnings are downloadable', 'FUNCTIONALITY', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (401, 'Drugbank problem after update of their interface', 'BUG_FIX', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (402, 'Autorefresh functionality', 'BUG_FIX', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (424, 'Comment in left panel (for touch interface)', 'FUNCTIONALITY', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (432, 'Complex map (composed from many small maps)', 'FUNCTIONALITY', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (434, 'Visualization of Recon specific annotations', 'FUNCTIONALITY', (select iddb from external_project where name ='RECON'), (select iddb from external_user where email ='ronan.mt.fleming@gmail.com'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (437, 'Visualization of posttranslationa modification', 'BUG_FIX', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (440, 'Reporting of drawing problems', 'BUG_FIX', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));


-- UPDATE 7/fix_db_20150325.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (443, 'Versioning system ', 'FUNCTIONALITY', null, (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));


-- UPDATE 7/fix_db_20150331.sql

-- galaxy connector
insert into external_user (name, surname, email) values ('Venkata', 'Satagopam', 'venkata.satagopam@uni.lu');
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (453, 'Galaxy connector', 'FUNCTIONALITY', null, (select iddb from external_user where email ='venkata.satagopam@uni.lu'));

-- miriam type information
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values (454, 'Miriam types report', 'FUNCTIONALITY', null, (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 7/fix_db_20150408.sql

-- miriam parsing bug
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (459, 'Problem with some miriam entries in RDF format', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));


-- UPDATE 7/fix_db_20150409.sql

-- update annotator class information
update cache_type set classname = 'lcsb.mapviewer.annotation.services.annotators.BiocompendiumAnnotator' where classname = 'lcsb.mapviewer.annotation.services.AnnotationRestService';
update cache_type set classname = 'lcsb.mapviewer.annotation.services.annotators.ChebiAnnotator' where classname = 'lcsb.mapviewer.annotation.services.ChebiBackend';
update cache_type set classname = 'lcsb.mapviewer.annotation.services.annotators.GoAnnotator' where classname = 'lcsb.mapviewer.annotation.services.GoBackend';

-- new annotator (uniprot)
insert into  cache_type (iddb, validity, classname) values (11, 28, 'lcsb.mapviewer.annotation.services.annotators.UniprotAnnotator');


-- UPDATE 7/fix_db_20150413.sql

-- uniprot annotator
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (462, 'Advanced annotation options', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (462, 'Uniprot annotation module', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 7/fix_db_20150416.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (465, 'Customized validation of miriam annotations', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 7/fix_db_20150420.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (463, 'User privileges for adding project', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (464, 'Data autofill problem in user management', 'BUG_FIX', null, 
  (select iddb from external_user where email ='stephan.gebel@uni.lu'));


-- UPDATE 7/fix_db_20150423.sql

-- recon annotator
insert into cache_type (iddb,validity, classname) values (12,28,'lcsb.mapviewer.annotation.services.annotators.ReconAnnotator') ;


-- UPDATE 7/fix_db_20150424.sql

-- recon annotator
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (467, 'Recon annotation service', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='ronan.mt.fleming@gmail.com'));


-- UPDATE 7/fix_db_20150522.sql

-- searching by annotations
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (472, 'Searching by annotations', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='stephan.gebel@uni.lu'));


-- UPDATE 7/fix_db_20150528.sql

-- searching by annotations
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (474, 'Session scope fixed (browsing many maps at the same time)', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
--on client side maps are asynchronously added/removed, and info about map changes in project list is updated by polling
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (474, 'Asynchronous removing/adding maps', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 7/fix_db_20150609.sql

--hgnc annotator (and cache store)
insert into cache_type (iddb,validity,classname) values (13,365,'lcsb.mapviewer.annotation.services.annotators.HgncAnnotator');


-- UPDATE 7/fix_db_20150629.sql

-- tables that contain information about images with the overview of the map
DROP table IF EXISTS overview_link_table;
DROP sequence IF EXISTS overview_link_iddb_seq;
DROP table IF EXISTS overview_image_table;
DROP sequence IF EXISTS overview_image_iddb_seq;

CREATE SEQUENCE overview_image_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE overview_image_iddb_seq
  OWNER TO map_viewer;

CREATE TABLE overview_image_table
(
  iddb integer NOT NULL DEFAULT nextval('overview_image_iddb_seq'::regclass),
  model_iddb integer,
  filename character varying(255),
  width integer,
  height integer,

  CONSTRAINT overview_image_pkey PRIMARY KEY (iddb),
  CONSTRAINT overview_image_model_fk FOREIGN KEY (model_iddb)
      REFERENCES model_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE overview_image_table
  OWNER TO map_viewer;

CREATE SEQUENCE overview_link_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE overview_image_iddb_seq
  OWNER TO map_viewer;

  

CREATE TABLE overview_link_table
(
  iddb integer NOT NULL DEFAULT nextval('overview_link_iddb_seq'::regclass),
  overviewimage_iddb integer,
  polygon character varying,
  zoomlevel integer,
  ycoord integer,
  xcoord integer,
  link_type character varying(31) NOT NULL,
  linkedoverviewimage_iddb integer,
  linkedmodel_iddb integer,

  CONSTRAINT overview_link_pkey PRIMARY KEY (iddb),
  CONSTRAINT overview_link_overview_image_fk FOREIGN KEY (overviewimage_iddb)
      REFERENCES overview_image_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT overview_link_linked_overview_image_fk FOREIGN KEY (linkedoverviewimage_iddb)
      REFERENCES overview_image_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT overview_image_model_fk FOREIGN KEY (linkedmodel_iddb)
      REFERENCES model_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
  
)
WITH (
  OIDS=FALSE
);
ALTER TABLE overview_image_table
  OWNER TO map_viewer;


-- map project directory (where all data will be stored on the server side)
alter table project_table add column directory character varying;

-- UPDATE 7/fix_db_20150707.sql

--sometimes when exporting celldesigner file to cml converter produced corrupted output
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (480, 'Export to CellDesigner rarely produced corrupted CellDEsigner file', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));

-- longfei
insert into external_user (name, surname, email) values ('Longfei', 'Mao', 'longfei.mao@uni.lu');

-- bugfix in recon
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (480, 'Recon annotations of reactions', 'BUG_FIX', 
  (select iddb from external_project where name ='RECON'), 
  (select iddb from external_user where email ='longfei.mao@uni.lu'));


-- UPDATE 7/fix_db_20150708.sql

-- data for new class: overview search link 
alter table overview_link_table add column query character varying;

-- UPDATE 7/fix_db_20150717.sql

--when user logged in and was browsing non-standard map then he was redirected to the standard map
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (480, 'Login problem when browsing not default map', 'BUG_FIX', null, 
  (select iddb from external_user where email ='stephan.gebel@uni.lu'));


-- UPDATE 7/fix_db_20150720.sql

--set default value for multimers from previus version of the system
update species_table set homodimer = 1 where homodimer is null;

-- alexander
insert into external_user (name, surname, email) values ('Alexander', 'Mazein', 'amazein@eisbm.org');

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (480, 'Multimers are available for every element', 'BUG_FIX', null, 
  (select iddb from external_user where email ='amazein@eisbm.org'));
  


-- UPDATE 7/fix_db_20150721.sql

-- information about display format
alter table model_table
add column sbgnformat boolean default false;
update model_table
set sbgnformat = false;
alter table model_table
alter column sbgnformat set not null;

insert into framework_version(version,"time", svnversion) values (6, timestamp'2015-07-21',510);
update framework_version set svnversion=514 where version = 6;

-- UPDATE 7/fix_db_20150722.sql

alter table alias_table add column aliasstatelabel character varying(255);
alter table alias_table add column aliasstateprefix character varying(255);


-- UPDATE 7/fix_db_20150818.sql

alter table layout add column inputdata bytea;
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (533, 'Uploaded datasets are available for download', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));



-- UPDATE 7/fix_db_20150820.sql

--entrez annotator (and cache store)
insert into cache_type (iddb,validity,classname) values (14,365,'lcsb.mapviewer.annotation.services.annotators.EntrezAnnotator');

--ensembl annotator (and cache store)
insert into cache_type (iddb,validity,classname) values (15,365,'lcsb.mapviewer.annotation.services.annotators.EnsemblAnnotator');

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (535, 'Entrez annotator', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (535, 'Ensembl annotator', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));



-- UPDATE 7/fix_db_20150821.sql

-- remove old IdConverter class
delete from cache_type where classname ='lcsb.mapviewer.annotation.services.IdConverter';

-- and data that was sotred for this converter
delete from cachequery where type = 5;

-- add foreign key that was missing
alter table cachequery add constraint cachequery_type_fk foreign key(type) 
	references cache_type(iddb) match simple
	ON UPDATE NO ACTION ON DELETE NO ACTION;



-- UPDATE 7/fix_db_20150824.sql

alter table user_table add column annotationschema_iddb integer;

alter table user_table drop CONSTRAINT if exists user_user_annotation_schema_fk;

DROP table IF EXISTS class_annotator_annotators_table;
DROP table IF EXISTS class_required_annotation_miriam_type_table;
DROP table IF EXISTS class_valid_annotation_miriam_type_table;
DROP table IF EXISTS class_annotator_table;
DROP table IF EXISTS class_required_annotation_table;
DROP table IF EXISTS class_valid_annotation_table;
DROP table IF EXISTS user_annotation_schema_table;
DROP sequence IF EXISTS user_annotation_schema_iddb_seq;
DROP sequence IF EXISTS class_valid_annotation_iddb_seq;
DROP sequence IF EXISTS class_required_annotation_iddb_seq;
DROP sequence IF EXISTS class_annotator_iddb_seq;

CREATE SEQUENCE user_annotation_schema_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE user_annotation_schema_iddb_seq
  OWNER TO map_viewer;

CREATE TABLE user_annotation_schema_table
(
  iddb integer NOT NULL DEFAULT nextval('user_annotation_schema_iddb_seq'::regclass),
  user_iddb integer,
  validatemiriamtypes boolean,

  CONSTRAINT user_annotation_schema_pkey PRIMARY KEY (iddb),
  CONSTRAINT user_annotation_schema_user_fk FOREIGN KEY (user_iddb)
      REFERENCES user_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE user_annotation_schema_table
  OWNER TO map_viewer;
  
alter table user_table add CONSTRAINT user_user_annotation_schema_fk FOREIGN KEY (annotationschema_iddb)
      REFERENCES user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
  

CREATE SEQUENCE class_valid_annotation_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE class_valid_annotation_iddb_seq
  OWNER TO map_viewer;

CREATE TABLE class_valid_annotation_table
(
  iddb integer NOT NULL DEFAULT nextval('class_valid_annotation_iddb_seq'::regclass),
  annotationschema_iddb integer,
  classname character varying(255),

  CONSTRAINT class_valid_annotation_pkey PRIMARY KEY (iddb),
  CONSTRAINT class_valid_annotation_user_annotation_schema_fk FOREIGN KEY (annotationschema_iddb)
      REFERENCES user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE class_valid_annotation_table
  OWNER TO map_viewer;


CREATE SEQUENCE class_annotator_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE class_annotator_iddb_seq
  OWNER TO map_viewer;

CREATE TABLE class_annotator_table
(
  iddb integer NOT NULL DEFAULT nextval('class_annotator_iddb_seq'::regclass),
  annotationschema_iddb integer,
  classname character varying(255),

  CONSTRAINT class_annotator_pkey PRIMARY KEY (iddb),
  CONSTRAINT class_annotator_user_annotation_schema_fk FOREIGN KEY (annotationschema_iddb)
      REFERENCES user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE class_annotator_table
  OWNER TO map_viewer;


CREATE TABLE class_annotator_annotators_table
(
  class_annotator_iddb integer NOT NULL,
  idx integer NOT NULL,
  annotator_name character varying(255),

  CONSTRAINT class_annotator_annotators_fk FOREIGN KEY (class_annotator_iddb)
      REFERENCES class_annotator_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE class_annotator_table
  OWNER TO map_viewer;


CREATE TABLE class_valid_annotation_miriam_type_table
(
  class_valid_annotation_iddb integer NOT NULL,
  idx integer NOT NULL,
  miriam_type_name character varying(255),

  CONSTRAINT class_valid_annotation_miriam_type_fk FOREIGN KEY (class_valid_annotation_iddb)
      REFERENCES class_valid_annotation_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE class_valid_annotation_miriam_type_table
  OWNER TO map_viewer;

CREATE SEQUENCE class_required_annotation_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE class_required_annotation_iddb_seq
  OWNER TO map_viewer;

CREATE TABLE class_required_annotation_table
(
  iddb integer NOT NULL DEFAULT nextval('class_required_annotation_iddb_seq'::regclass),
  annotationschema_iddb integer,
  requireatlestoneannotation boolean,
  classname character varying(255),

  CONSTRAINT class_required_annotation_pkey PRIMARY KEY (iddb),
  CONSTRAINT class_required_annotation_user_annotation_schema_fk FOREIGN KEY (annotationschema_iddb)
      REFERENCES user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE class_required_annotation_table
  OWNER TO map_viewer;

CREATE TABLE class_required_annotation_miriam_type_table
(
  class_required_annotation_iddb integer NOT NULL,
  idx integer NOT NULL,
  miriam_type_name character varying(255),

  CONSTRAINT class_required_annotation_miriam_type_fk FOREIGN KEY (class_required_annotation_iddb)
      REFERENCES class_required_annotation_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE class_required_annotation_miriam_type_table
  OWNER TO map_viewer;


-- UPDATE 7/fix_db_20150826.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (539, 'Valid/required annotations and used annotations saved in user profile', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));



-- UPDATE 7/fix_db_20150828.sql

DROP table IF EXISTS data_mining_set_table;
DROP sequence IF EXISTS data_mining_set_iddb_seq;

CREATE SEQUENCE data_mining_set_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE data_mining_set_iddb_seq
  OWNER TO map_viewer;

CREATE TABLE data_mining_set_table
(
  iddb integer NOT NULL DEFAULT nextval('data_mining_set_iddb_seq'::regclass),
  model_iddb integer,
  name character varying(255),
  description character varying(255),
  source character varying(255),
  inputdata bytea,
  type integer,

  CONSTRAINT data_mining_set_table_pkey PRIMARY KEY (iddb),
  CONSTRAINT data_mining_set_table_model_fk FOREIGN KEY (model_iddb)
      REFERENCES model_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE data_mining_set_table
  OWNER TO map_viewer;


-- UPDATE 7/fix_db_20150910.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (555, 'Export to pdf/png/jpg/svg', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));

-- UPDATE 7/fix_db_20150915.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (561, 'New web interface', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));

-- UPDATE 7/fix_db_20150917.sql

alter table project_table rename name to project_id;
alter table project_table add column name varchar(255);

update configuration_table set value = 'udl.png' where type = 8;

-- UPDATE 7/fix_db_20150918.sql

-- add unique constraints

ALTER TABLE project_table ADD CONSTRAINT unique_project_id UNIQUE (project_id);

update user_table set login = login || '_' || cast (iddb as text) where removed = true;

ALTER TABLE user_table ADD CONSTRAINT unique_user_login UNIQUE (login);


-- UPDATE 7/fix_db_20151001.sql

ALTER TABLE datamining_miriam_data_table RENAME CONSTRAINT references_table_miriam_pkey TO datamining_miriam_data_pkey;
ALTER TABLE datamining_miriam_data_table RENAME CONSTRAINT references_table_foreign_key TO datamining_miriam_data_foreign_key;
ALTER TABLE datamining_miriam_data_table RENAME CONSTRAINT references_table_foreign_miriam_key TO datamining_miriam_data_foreign_miriam_key;
ALTER TABLE datamining_miriam_data_table RENAME CONSTRAINT references_table_unique_miriam TO datamining_miriam_data_unique_miriam;


-- UPDATE 7/fix_db_20151027.sql

alter table user_annotation_schema_table add column networklayoutasdefault boolean default false;
alter table user_annotation_schema_table add column sbgnformat boolean default false;



-- UPDATE 7/fix_db_20151120.sql

-- fixing privileges for admin (adding project is availabvle by default for admin)
insert into privilege_table (privilege_class_type_db,level,type,idobject,user_iddb) select 'BASIC_PRIVILEGE',1,1,null, t.iddb from user_table t where iddb=1 and not(t.iddb in (select user_iddb from privilege_table where type=1));


-- UPDATE 7/fix_db_20151203.sql

insert into framework_version(version,"time", svnversion) values (7, timestamp'2015-12-03',777);


-- UPDATE 8/fix_db_20151214.sql

INSERT INTO cache_type(iddb, validity, classname)
VALUES (16, 28, 'lcsb.mapviewer.annotation.services.ChemicalParser');
INSERT INTO cache_type(iddb, validity, classname)
VALUES (17, 28, 'lcsb.mapviewer.annotation.services.MeSHParser');
INSERT INTO cache_type(iddb, validity, classname)
VALUES (18, 28, 'lcsb.mapviewer.annotation.services.MiRNAParser');

AlTER TABLE project_table 
ADD column disease_iddb integer;
ALTER TABLE project_table
  ADD CONSTRAINT project_table_miriam FOREIGN KEY (disease_iddb)
      REFERENCES miriam_data_table (iddb);
UPDATE cache_type
SET  classname= 'lcsb.mapviewer.annotation.services.PubmedParser'
where iddb = 3;


-- UPDATE 8/fix_db_20160128.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (851, 'Data sets (layouts) visualized dynamically in the browser', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (851, 'Micro RNA database', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='stephan.gebel@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (851, 'Chemical database', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='stephan.gebel@uni.lu'));
  

-- UPDATE 8/fix_db_20160311.sql

--structures of drugs changed 
delete from cachequery where type = 2 or type = 4;

--more data in mirna
delete from cachequery where type = 16 or type = 18;



-- UPDATE 8/fix_db_20160324.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (936, 'Reverse query for drugs, chemicals, micro RNAs interfaces', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  

-- UPDATE 8/fix_db_20160428.sql

-- default empty project should have apropriate status (but only when it exists)
update project_table set status = 7, progress = 100 where project_id='empty' and status =0 and progress =0;


-- UPDATE 8/fix_db_20160517.sql

insert into framework_version(version,"time", svnversion) values (8, timestamp'2016-05-17',1004);


-- UPDATE 9/fix_db_20160629.sql

insert into cache_type select 3,365,'lcsb.mapviewer.annotation.services.MiriamConnector' where (select count(*) from cache_type where iddb = 3) =0;

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1022, 'Installation script fixed', 'BUG_FIX', null, null);

insert into framework_version(version,"time", svnversion) values (9, timestamp'2016-06-29',1023);


-- UPDATE 10/fix_db_20160517.sql

-- remove metaid columns (some useless identifier)
alter table species_table drop column metaid;
alter table reaction_table drop column metaid;
alter table model_table drop column metaid;


-- UPDATE 10/fix_db_20160518.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Search by reaction id is not case sensitive', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'CellDesigner font size is processed properly', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));

--column with input file data for a project
alter table project_table add column inputdata bytea;
ALTER TABLE project_table ADD COLUMN inputfilename varchar;

-- UPDATE 10/fix_db_20160519.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Project info tab available for users', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 10/fix_db_20160520.sql

INSERT INTO cache_type(iddb, validity, classname)
VALUES (19, 28, 'lcsb.mapviewer.annotation.services.genome.UcscReferenceGenomeConnector');


-- UPDATE 10/fix_db_20160523.sql

CREATE SEQUENCE public.big_file_entry_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.big_file_entry
(
  iddb integer NOT NULL DEFAULT nextval('big_file_entry_iddb_seq'::regclass),
  url text,
  localpath text,
  downloaddate timestamp without time zone,
  downloadprogress double precision,
  downloadthreadid integer,
  removed boolean default false,
  CONSTRAINT big_file_entry_pkey PRIMARY KEY (iddb)
)
WITH (
  OIDS=FALSE
);

ALTER TABLE public.big_file_entry
  OWNER TO map_viewer;
ALTER TABLE public.big_file_entry_iddb_seq
  OWNER TO map_viewer;

-- UPDATE 10/fix_db_20160524.sql

drop table if exists public.reference_genome;
drop SEQUENCE if exists public.reference_genome_iddb_seq;
CREATE SEQUENCE public.reference_genome_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.reference_genome
(
  iddb integer NOT NULL DEFAULT nextval('reference_genome_iddb_seq'::regclass),
  organism_iddb integer NOT NULL ,
  "type" varchar(255),
  version varchar(255),
  sourceurl text,
  downloadprogress double precision,
  CONSTRAINT reference_genome_pkey PRIMARY KEY (iddb),
  CONSTRAINT reference_genome_organism_fk FOREIGN KEY (organism_iddb)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);

ALTER TABLE public.reference_genome
  OWNER TO map_viewer;
ALTER TABLE public.reference_genome_iddb_seq
  OWNER TO map_viewer;

-- UPDATE 10/fix_db_20160527.sql

--obligatory fields for reference genome table
alter table reference_genome alter column "type" set not null;
alter table reference_genome alter column organism_iddb set not null;
alter table reference_genome alter column "version" set not null;


--gene mapping files table for reference genome table
drop table if exists public.reference_genome_gene_mapping;
drop SEQUENCE if exists public.reference_genome_gene_mapping_iddb_seq;
CREATE SEQUENCE public.reference_genome_gene_mapping_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.reference_genome_gene_mapping
(
  iddb integer NOT NULL DEFAULT nextval('reference_genome_gene_mapping_iddb_seq'::regclass),
  referencegenome_iddb integer NOT NULL,
  name varchar(255) not null,
  sourceurl text not null,
  downloadprogress double precision,
  CONSTRAINT reference_genome_gene_mapping_pkey PRIMARY KEY (iddb),
  CONSTRAINT reference_genome_gene_mapping_reference_genome_fk FOREIGN KEY (referencegenome_iddb)
      REFERENCES public.reference_genome (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT reference_genome_gene_mapping_unique_name UNIQUE (referencegenome_iddb, name)
      

)
WITH (
  OIDS=FALSE
);

ALTER TABLE public.reference_genome_gene_mapping
  OWNER TO map_viewer;
ALTER TABLE public.reference_genome_gene_mapping_iddb_seq
  OWNER TO map_viewer;

-- UPDATE 10/fix_db_20160601.sql

-- fixing privileges for admin (genome managing is availabvle by default for admin)
insert into privilege_table (privilege_class_type_db,level,type,idobject,user_iddb) select 'BASIC_PRIVILEGE',1,11,null, t.iddb from user_table t where iddb=1 and not(t.iddb in (select user_iddb from privilege_table where type=11));


-- UPDATE 10/fix_db_20160606.sql

-- project should have organism id
alter table project_table  add column organism_iddb integer;
ALTER TABLE project_table ADD CONSTRAINT project_organism_constraint FOREIGN KEY (organism_iddb)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

-- UPDATE 10/fix_db_20160621.sql

-- reorganizing files in the system
alter table big_file_entry rename to file_entry;

alter table file_entry add column filecontent bytea;
alter table file_entry add column file_type_db varchar(255);
alter table file_entry add column originalfilename varchar(255);

-- all files up to this point were big files
update file_entry set file_type_db = 'BIG_FILE_ENTRY';

--and now we move content of files from layout file to file_entry table
--tmp column
alter table file_entry add column layout_id_tmp integer;
--move content content
insert into file_entry (filecontent,file_type_db,originalfilename,layout_id_tmp) select inputdata, 'UPLOADED_FILE_ENTRY', 'layout_'||iddb||'.txt',iddb from layout where inputdata is not null;

--add foreign key
alter table layout add column file_entry_iddb integer;
ALTER TABLE layout ADD CONSTRAINT layout_file_constraint FOREIGN KEY (file_entry_iddb)
      REFERENCES public.file_entry (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

--put data to foreign key      
update layout l set file_entry_iddb = (select iddb from file_entry ef where ef.layout_id_tmp = l.iddb) where l.inputdata is not null;

--remove unused columns 
alter table file_entry drop column layout_id_tmp;
alter table layout drop column inputdata;


-- UPDATE 10/fix_db_20160629.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Hiding left panel', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Coordinates in url', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Unexpected errors when uploading layouts', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));

delete from cachequery where type = (select iddb from cache_type where classname = 'lcsb.mapviewer.annotation.services.DrugbankHTMLParser') and query like 'drug:%';

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Corrupted drug names', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));


-- UPDATE 10/fix_db_20160727.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Out of memory when caching a lot of data', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Management of overlays in admin panel', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Zooming issue when searching for results on submaps', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Exception when accessing non-existing project', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
  


-- UPDATE 10/fix_db_20160728.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1056, 'Visualization of text mining', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));


-- UPDATE 10/fix_db_20160822.sql

insert into framework_version(version,"time", svnversion) values (10, timestamp'2016-08-22',1119);


-- UPDATE 10.0.1/fix_db_20160907.sql

drop table changelog;
drop table framework_version;

-- UPDATE 10.0.1/fix_db_20160909.sql

-- fix on issue #8
update reaction_table set reaction_type_db='REDUCED_TRIGGER_REACTION' where reaction_type_db = 'TRIGGER_REACTION';
update reaction_table set reaction_type_db='REDUCED_PHYSICAL_STIMULATION' where reaction_type_db = 'PHYSICAL_STIMULATION_REACTION';



-- UPDATE 10.0.2/fix_db_20160928.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 10.0.3/fix_db_20160926.sql

-- change alias types for new aliases implementation 
update alias_table set alias_type_db = 'ANTISENSE_RNA_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Antisense RNA');

--chemical_alias (should never happen)
update alias_table set alias_type_db = 'CHEMICAL_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Chemical');

update alias_table set alias_type_db = 'ION_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Ion');

update alias_table set alias_type_db = 'SIMPLE_MOLECULE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='SimpleMolecule');

-- complex_alias (nothing should change)
update alias_table set alias_type_db = 'Complex Species Alias' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='COMPLEX_SPECIES');

update alias_table set alias_type_db = 'DEGRADED_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Degraded');

update alias_table set alias_type_db = 'DRUG_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Drug');

update alias_table set alias_type_db = 'GENE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Gene');

update alias_table set alias_type_db = 'PHENTOYPE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Phenotype');

-- protein_alias (this should never happen)
update alias_table set alias_type_db = 'PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Protein');

update alias_table set alias_type_db = 'GENERIC_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='GENERIC_PROTEIN');

update alias_table set alias_type_db = 'ION_CHANNEL_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='ION_CHANNEL_PROTEIN');

update alias_table set alias_type_db = 'RECEPTOR_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='RECEPTOR_PROTEIN');

update alias_table set alias_type_db = 'TRUNCATED_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='TRUNCATED_PROTEIN');

update alias_table set alias_type_db = 'RNA_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='RNA');

update alias_table set alias_type_db = 'UNKNOWN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Unknown');

-- for artifitial compartment alias we have name in the title column so rename it (later on we will add names for other elements)
ALTER TABLE "alias_table" RENAME COLUMN "title" TO "name";


-- UPDATE 10.0.3/fix_db_20160929.sql

-- migrate info about abbreviation
ALTER TABLE alias_table ADD COLUMN abbreviation character varying(255);
update alias_table set abbreviation = (select species_table.abbreviation from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column abbreviation;

-- migrate info about formula
ALTER TABLE alias_table ADD COLUMN formula character varying(255);
update alias_table set formula = (select species_table.formula from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column formula;

-- migrate info about full name
ALTER TABLE alias_table ADD COLUMN fullname character varying(255);
update alias_table set fullname = (select species_table.fullname from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column fullname;

-- name
update alias_table set name = (select species_table.name from species_table where alias_table.idelementdb =  species_table.iddb) where name is null or name ='';

-- notes
ALTER TABLE alias_table ADD COLUMN notes text;
update alias_table set notes = (select species_table.notes from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column notes;

-- symbol
ALTER TABLE alias_table ADD COLUMN symbol character varying(255);
update alias_table set symbol = (select species_table.symbol from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column symbol;

-- charge
ALTER TABLE alias_table ADD COLUMN charge integer;
update alias_table set charge = (select species_table.charge from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column charge;

-- homodimer
ALTER TABLE alias_table ADD COLUMN homodimer integer;
update alias_table set homodimer = (select species_table.homodimer from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column homodimer;

-- hypothetical
ALTER TABLE alias_table ADD COLUMN hypothetical boolean;
update alias_table set hypothetical = (select species_table.hypothetical from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column hypothetical;

-- initial amount
ALTER TABLE alias_table ADD COLUMN initialamount integer;
update alias_table set initialamount = (select species_table.initialamount from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column initialamount;

-- initial concentration
ALTER TABLE alias_table ADD COLUMN initialconcentration integer;
update alias_table set initialconcentration = (select species_table.initialconcentration from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column initialconcentration;

--only substance unit
ALTER TABLE alias_table ADD COLUMN onlysubstanceunits boolean;
update alias_table set onlysubstanceunits = (select species_table.onlysubstanceunits from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column onlysubstanceunits;

-- position to compartment
ALTER TABLE alias_table ADD COLUMN positiontocompartment character varying(255);
update alias_table set positiontocompartment = (select species_table.positiontocompartment from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column positiontocompartment;

-- inchi
ALTER TABLE alias_table ADD COLUMN inchi text;
update alias_table set inchi = (select species_table.inchi from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column inchi;

-- inchi key
ALTER TABLE alias_table ADD COLUMN inchikey character varying(255);
update alias_table set inchikey = (select species_table.inchikey from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column inchikey;

-- smiles
ALTER TABLE alias_table ADD COLUMN smiles text;
update alias_table set smiles = (select species_table.smiles from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column smiles;

-- structural state
ALTER TABLE alias_table ADD COLUMN structuralstate character varying(255);
update alias_table set structuralstate = (select species_table.structuralstate from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column structuralstate;


-- UPDATE 10.0.3/fix_db_20160930.sql

-- modification residues
	CREATE SEQUENCE modification_residue_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE modification_residue_table_new
(
  iddb integer NOT NULL DEFAULT nextval('modification_residue_table_iddb_seq'::regclass),
  angle double precision,
  idmodificationresidue character varying(255),
  name character varying(255),
  side character varying(255),
  size double precision,
  idspeciesdb integer NOT NULL,
  state integer,
  CONSTRAINT modification_residue_pkey PRIMARY KEY (iddb),
  CONSTRAINT modification_residue_species_fk FOREIGN KEY (idspeciesdb)
      REFERENCES public.alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO modification_residue_table_new (angle, idmodificationresidue, name, side, size, idspeciesdb,state) select modification_residue_table.angle, modification_residue_table.idmodificationresidue, modification_residue_table.name, modification_residue_table.side, modification_residue_table.size, alias_table.iddb, modification_residue_table.state from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join modification_residue_table on species_table.iddb = modification_residue_table.idspeciesdb;

drop table modification_residue_table;

-- mapping between miriam data and element
CREATE TABLE public.element_miriam
(
  element_id integer NOT NULL,
  miriam_id integer NOT NULL,
  CONSTRAINT element_miriam_pkey PRIMARY KEY (element_id, miriam_id),
  CONSTRAINT element_miriam_element_fk FOREIGN KEY (element_id)
      REFERENCES public.alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT element_miriam_miriam_fk FOREIGN KEY (miriam_id)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- migrate data
insert into element_miriam (miriam_id, element_id) select miriam_data_table.iddb, alias_table.iddb from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join miriam_data_table on species_table.iddb = miriam_data_table.element_iddb;

alter table miriam_data_table drop column element_iddb;

-- former symbol list
CREATE TABLE element_former_symbols_new
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  symbol character varying(255),
  CONSTRAINT element_former_symbols_pk PRIMARY KEY (iddb, idx),
  CONSTRAINT element_former_symbols_fk FOREIGN KEY (iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

insert into element_former_symbols_new (iddb, idx, symbol) 
select alias_table.iddb, element_former_symbols.idx, element_former_symbols.symbol from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join element_former_symbols on species_table.iddb = element_former_symbols.iddb;

drop table element_former_symbols;

---synonyms list
CREATE TABLE element_synonyms_new
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  synonym character varying(255),
  CONSTRAINT element_synonyms_pk PRIMARY KEY (iddb, idx),
  CONSTRAINT element_synonyms_fk FOREIGN KEY (iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

insert into element_synonyms_new (iddb, idx, synonym) 
select alias_table.iddb, element_synonyms.idx, element_synonyms.synonym from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join element_synonyms on species_table.iddb = element_synonyms.iddb;

drop table element_synonyms;

--- antisense rna regions
CREATE TABLE antisense_rna_region_table_new
(
  iddb integer NOT NULL DEFAULT nextval('antisense_rna_region_table_iddb_seq'::regclass),
  idantisensernaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  idspeciesdb integer,
  state integer,
  type integer,
  CONSTRAINT antisense_rna_region_table_pk PRIMARY KEY (iddb),
  CONSTRAINT antisense_rna_region_table_fk FOREIGN KEY (idspeciesdb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO antisense_rna_region_table_new ( idantisensernaregion, name, pos, size, idspeciesdb,state,type) 
select antisense_rna_region_table.idantisensernaregion, antisense_rna_region_table.name, antisense_rna_region_table.pos, antisense_rna_region_table.size, alias_table.iddb, antisense_rna_region_table.state, antisense_rna_region_table.type from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join antisense_rna_region_table on species_table.iddb = antisense_rna_region_table.idspeciesdb;

drop table antisense_rna_region_table;

-- rna
-- modification residues
CREATE SEQUENCE rna_region_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE rna_region_table_new
(
  iddb integer NOT NULL DEFAULT nextval('rna_region_table_iddb_seq'::regclass),
  idrnaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  idspeciesdb integer,
  state integer,
  type character varying(255),
  CONSTRAINT rna_region_table_pk PRIMARY KEY (iddb),
  CONSTRAINT rna_region_table_fk FOREIGN KEY (idspeciesdb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO rna_region_table_new ( idrnaregion, name, pos, size, idspeciesdb,state) 
select rna_region_table.idrnaregion, rna_region_table.name, rna_region_table.pos, rna_region_table.size, alias_table.iddb, rna_region_table.state from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join rna_region_table on species_table.iddb = rna_region_table.idspeciesdb;

drop table rna_region_table;
drop sequence rna_region_table_idrnaregiondb_seq;


-- UPDATE 10.0.3/fix_db_20161003.sql

-- data mining
CREATE SEQUENCE datamining_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE datamining_table
(
  iddb integer NOT NULL DEFAULT nextval('datamining_table_iddb_seq'::regclass),
  old_idbb integer,
  description text,
  type integer,
  element_iddb integer NOT NULL,
  CONSTRAINT missingconnection_pk PRIMARY KEY (iddb),
  CONSTRAINT missingconnection_fk FOREIGN KEY (element_iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_table ( old_idbb, description, type, element_iddb) 
select datamining.iddb, datamining.description, datamining.type, alias_table.iddb as element_iddb from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join datamining on species_table.iddb = datamining.element_iddb;

CREATE TABLE datamining_references
(
  idx integer NOT NULL,
  datamining_iddb integer NOT NULL,
  references_iddb integer NOT NULL,
  CONSTRAINT datamining_references_pk PRIMARY KEY (datamining_iddb, idx),
  CONSTRAINT datamining_references_fk_data_mining FOREIGN KEY (datamining_iddb)
      REFERENCES datamining_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_references_fk_miriam FOREIGN KEY (references_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_references ( idx, datamining_iddb, references_iddb) 
select datamining_miriam_data_table.idx, datamining_table.iddb, datamining_miriam_data_table.references_iddb from datamining_table inner join datamining_miriam_data_table on datamining_table.old_idbb = datamining_miriam_data_table.datamining_iddb ;

drop table datamining_miriam_data_table;
alter table datamining_references rename column datamining_iddb  to datamining_table_iddb ;


drop table if exists datamining_connections;
CREATE TABLE datamining_connections
(
  idx integer NOT NULL,
  datamining_table_iddb integer NOT NULL,
  suggestedconnections_iddb integer NOT NULL,
  CONSTRAINT datamining_connections_pk PRIMARY KEY (datamining_table_iddb, idx),
  CONSTRAINT datamining_connections_fk_data_mining FOREIGN KEY (datamining_table_iddb)
      REFERENCES datamining_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_connections_fk_miriam FOREIGN KEY (suggestedconnections_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_connections ( idx, datamining_table_iddb, suggestedconnections_iddb) 
select datamining_suggested_connections.idx, datamining_table.iddb, datamining_suggested_connections.suggestedconnections_iddb from datamining_table inner join datamining_suggested_connections on datamining_table.old_idbb = datamining_suggested_connections.datamining_iddb ;

drop table datamining_suggested_connections;

alter table datamining_table drop column old_idbb;

drop table datamining;

drop table associated_phenotype_element_table;

drop table external_project;
drop table external_user;

-- clean info about annotations
delete from class_annotator_annotators_table  ;
delete from class_annotator_table  ;
delete from class_required_annotation_miriam_type_table  ;
delete from class_required_annotation_table  ;
delete from class_valid_annotation_miriam_type_table  ;
delete from class_valid_annotation_table  ;
update user_table  set annotationschema_iddb =null;
delete from user_annotation_schema_table;


-- UPDATE 10.0.3/fix_db_20161004.sql

-- drop old species implementation

alter table node_table drop column element_iddb;
alter table alias_table drop column idelementdb;
drop table species_table;

alter table alias_table rename column aliasid to elementid;


-- UPDATE 10.0.3/fix_db_20161005.sql

alter table submodel_connection_table rename fromalias_iddb to fromelement_iddb;
alter table submodel_connection_table rename toalias_iddb to toelement_iddb;

alter table alias_table rename to element_table;

update element_table set alias_type_db ='Bottom square Compartment' where alias_type_db = 'Bottom square Compartment Alias';
update element_table set alias_type_db ='Left square Compartment' where alias_type_db = 'Left square Compartment Alias';
update element_table set alias_type_db ='Oval Compartment' where alias_type_db = 'Oval Compartment Alias';
update element_table set alias_type_db ='Compartment' where alias_type_db = 'Compartment Alias';
update element_table set alias_type_db ='Pathway Compartment' where alias_type_db = 'Artifitial Compartment Alias';
update element_table set alias_type_db ='Right square Compartment' where alias_type_db = 'Right square Compartment Alias';
update element_table set alias_type_db ='Square Compartment' where alias_type_db = 'Square Compartment Alias';
update element_table set alias_type_db ='Top square Compartment' where alias_type_db = 'Top square Compartment Alias';

alter table node_table drop column element_iddb;
alter table node_table rename alias_iddb to element_iddb;

update element_table set alias_type_db ='Complex' where alias_type_db = 'Complex Species Alias';
update element_table set alias_type_db ='Species' where alias_type_db = 'Species Alias';

alter table element_table rename alias_type_db  to element_type_db;
alter table element_table  rename idcomplexaliasdb to idcomplexdb;

alter table element_table  rename aliasstatelabel to statelabel;
alter table element_table  rename aliasstateprefix to stateprefix;


-- UPDATE 10.0.3/fix_db_20161006.sql

alter table element_table  rename compartmentalias_iddb to compartment_iddb;


-- UPDATE 10.0.3/fix_db_20161007.sql

update element_table set idcomplexdb=parent_iddb where idcomplexdb is null and parent_iddb is not null and parent_iddb in (select iddb from element_table where element_type_db= 'Complex');

update element_table set compartment_iddb = parent_iddb where compartment_iddb is null and parent_iddb is not null and parent_iddb in (select iddb from element_table where element_type_db<> 'Complex');

alter table element_table  drop COLUMN parent_iddb ;

alter SEQUENCE alias_table_iddb_seq rename to element_table_iddb_seq;

drop sequence associated_phenotype_element_table_iddb_seq;

drop sequence layout_iddb_seq;

alter sequence layout_iddb_seq1 rename to layout_iddb_seq;

drop sequence search_index_table_iddb_seq;

alter sequence search_index_table_iddb_seq1 rename to search_index_table_iddb_seq;

alter table antisense_rna_region_table_new RENAME to antisense_rna_region_table;
alter table element_former_symbols_new rename to element_former_symbols;
alter table element_synonyms_new rename to element_synonyms;
alter table modification_residue_table_new rename to modification_residue_table;
alter table rna_region_table_new rename to rna_region_table;


-- UPDATE 10.0.3/fix_db_20161010.sql

DROP TABLE IF EXISTS layerline;

update  miriam_data_table set datatype='MI_R_BASE_SEQUENCE' where datatype  ='MI_RBASE_SEQUENCE';


-- UPDATE 10.0.3/fix_db_20161012.sql

alter table user_table add column maxcolor bytea;
alter table user_table add column mincolor bytea;


-- UPDATE 10.0.3/fix_db_20161026.sql

--merging project and model logs
alter table project_table add column warnings text;
update project_table set warnings = (select creationwarnings from model_table  where project_iddb = project_table.iddb);

alter table model_table drop column creationwarnings;


-- UPDATE 10.0.3/fix_db_20161027.sql

--sbgn format moved from model into project
alter table project_table add column sbgnformat boolean default false ;
update project_table set sbgnformat = (select sbgnformat from model_table  where project_iddb = project_table.iddb);

alter table model_table drop column sbgnformat;

--PrivilegeType should be mapped in database by name not by index
alter table privilege_table add column type_string character varying;
update privilege_table set type_string = 'VIEW_PROJECT' where type = 0;
update privilege_table set type_string = 'ADD_MAP' where type = 1;
update privilege_table set type_string = 'EDIT_MISSING_CONNECTIONS_PROJECT' where type = 2;
update privilege_table set type_string = 'EDIT_COMMENTS_PROJECT' where type = 3;
update privilege_table set type_string = 'DRUG_TARGETING_ADVANCED_VIEW_PROJECT' where type = 4;
update privilege_table set type_string = 'PROJECT_MANAGEMENT' where type = 5;
update privilege_table set type_string = 'USER_MANAGEMENT' where type = 6;
update privilege_table set type_string = 'CUSTOM_LAYOUTS' where type = 7;
update privilege_table set type_string = 'LAYOUT_VIEW' where type = 8;
update privilege_table set type_string = 'CONFIGURATION_MANAGE' where type = 9;
update privilege_table set type_string = 'LAYOUT_MANAGEMENT' where type = 10;
update privilege_table set type_string = 'MANAGE_GENOMES' where type = 11;
alter table privilege_table drop column type;
alter table privilege_table rename type_string   TO type;


-- UPDATE 10.0.4/fix_db_20161215.sql

-- fix on comment visibility in new version
update feedback set tablename = 'lcsb.mapviewer.model.map.species.Species' where tablename='lcsb.mapviewer.model.map.layout.alias.SpeciesAlias';
update feedback set tablename = 'lcsb.mapviewer.model.map.species.Complex' where tablename='lcsb.mapviewer.model.map.layout.alias.ComplexAlias';

-- UPDATE 10.0.4/fix_db_20161228.sql

-- fix on drugbank parser
delete from cachequery where query like 'drug:%' and type in (select iddb from cache_type  where classname ='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');
delete from cachequery where query like 'http:%' and type in (select iddb from cache_type  where classname ='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');


-- UPDATE 10.0.5/fix_db_20170131.sql

-- empty file to force directory to be commited to git repo
