

-- UPDATE 10.0.1/fix_db_20160907.sql

drop table changelog;
drop table framework_version;

-- UPDATE 10.0.1/fix_db_20160909.sql

-- fix on issue #8
update reaction_table set reaction_type_db='REDUCED_TRIGGER_REACTION' where reaction_type_db = 'TRIGGER_REACTION';
update reaction_table set reaction_type_db='REDUCED_PHYSICAL_STIMULATION' where reaction_type_db = 'PHYSICAL_STIMULATION_REACTION';



-- UPDATE 10.0.2/fix_db_20160928.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 10.0.3/fix_db_20160926.sql

-- change alias types for new aliases implementation 
update alias_table set alias_type_db = 'ANTISENSE_RNA_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Antisense RNA');

--chemical_alias (should never happen)
update alias_table set alias_type_db = 'CHEMICAL_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Chemical');

update alias_table set alias_type_db = 'ION_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Ion');

update alias_table set alias_type_db = 'SIMPLE_MOLECULE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='SimpleMolecule');

-- complex_alias (nothing should change)
update alias_table set alias_type_db = 'Complex Species Alias' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='COMPLEX_SPECIES');

update alias_table set alias_type_db = 'DEGRADED_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Degraded');

update alias_table set alias_type_db = 'DRUG_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Drug');

update alias_table set alias_type_db = 'GENE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Gene');

update alias_table set alias_type_db = 'PHENTOYPE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Phenotype');

-- protein_alias (this should never happen)
update alias_table set alias_type_db = 'PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Protein');

update alias_table set alias_type_db = 'GENERIC_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='GENERIC_PROTEIN');

update alias_table set alias_type_db = 'ION_CHANNEL_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='ION_CHANNEL_PROTEIN');

update alias_table set alias_type_db = 'RECEPTOR_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='RECEPTOR_PROTEIN');

update alias_table set alias_type_db = 'TRUNCATED_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='TRUNCATED_PROTEIN');

update alias_table set alias_type_db = 'RNA_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='RNA');

update alias_table set alias_type_db = 'UNKNOWN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Unknown');

-- for artifitial compartment alias we have name in the title column so rename it (later on we will add names for other elements)
ALTER TABLE "alias_table" RENAME COLUMN "title" TO "name";


-- UPDATE 10.0.3/fix_db_20160929.sql

-- migrate info about abbreviation
ALTER TABLE alias_table ADD COLUMN abbreviation character varying(255);
update alias_table set abbreviation = (select species_table.abbreviation from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column abbreviation;

-- migrate info about formula
ALTER TABLE alias_table ADD COLUMN formula character varying(255);
update alias_table set formula = (select species_table.formula from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column formula;

-- migrate info about full name
ALTER TABLE alias_table ADD COLUMN fullname character varying(255);
update alias_table set fullname = (select species_table.fullname from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column fullname;

-- name
update alias_table set name = (select species_table.name from species_table where alias_table.idelementdb =  species_table.iddb) where name is null or name ='';

-- notes
ALTER TABLE alias_table ADD COLUMN notes text;
update alias_table set notes = (select species_table.notes from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column notes;

-- symbol
ALTER TABLE alias_table ADD COLUMN symbol character varying(255);
update alias_table set symbol = (select species_table.symbol from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column symbol;

-- charge
ALTER TABLE alias_table ADD COLUMN charge integer;
update alias_table set charge = (select species_table.charge from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column charge;

-- homodimer
ALTER TABLE alias_table ADD COLUMN homodimer integer;
update alias_table set homodimer = (select species_table.homodimer from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column homodimer;

-- hypothetical
ALTER TABLE alias_table ADD COLUMN hypothetical boolean;
update alias_table set hypothetical = (select species_table.hypothetical from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column hypothetical;

-- initial amount
ALTER TABLE alias_table ADD COLUMN initialamount integer;
update alias_table set initialamount = (select species_table.initialamount from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column initialamount;

-- initial concentration
ALTER TABLE alias_table ADD COLUMN initialconcentration integer;
update alias_table set initialconcentration = (select species_table.initialconcentration from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column initialconcentration;

--only substance unit
ALTER TABLE alias_table ADD COLUMN onlysubstanceunits boolean;
update alias_table set onlysubstanceunits = (select species_table.onlysubstanceunits from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column onlysubstanceunits;

-- position to compartment
ALTER TABLE alias_table ADD COLUMN positiontocompartment character varying(255);
update alias_table set positiontocompartment = (select species_table.positiontocompartment from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column positiontocompartment;

-- inchi
ALTER TABLE alias_table ADD COLUMN inchi text;
update alias_table set inchi = (select species_table.inchi from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column inchi;

-- inchi key
ALTER TABLE alias_table ADD COLUMN inchikey character varying(255);
update alias_table set inchikey = (select species_table.inchikey from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column inchikey;

-- smiles
ALTER TABLE alias_table ADD COLUMN smiles text;
update alias_table set smiles = (select species_table.smiles from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column smiles;

-- structural state
ALTER TABLE alias_table ADD COLUMN structuralstate character varying(255);
update alias_table set structuralstate = (select species_table.structuralstate from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column structuralstate;


-- UPDATE 10.0.3/fix_db_20160930.sql

-- modification residues
	CREATE SEQUENCE modification_residue_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE modification_residue_table_new
(
  iddb integer NOT NULL DEFAULT nextval('modification_residue_table_iddb_seq'::regclass),
  angle double precision,
  idmodificationresidue character varying(255),
  name character varying(255),
  side character varying(255),
  size double precision,
  idspeciesdb integer NOT NULL,
  state integer,
  CONSTRAINT modification_residue_pkey PRIMARY KEY (iddb),
  CONSTRAINT modification_residue_species_fk FOREIGN KEY (idspeciesdb)
      REFERENCES public.alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO modification_residue_table_new (angle, idmodificationresidue, name, side, size, idspeciesdb,state) select modification_residue_table.angle, modification_residue_table.idmodificationresidue, modification_residue_table.name, modification_residue_table.side, modification_residue_table.size, alias_table.iddb, modification_residue_table.state from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join modification_residue_table on species_table.iddb = modification_residue_table.idspeciesdb;

drop table modification_residue_table;

-- mapping between miriam data and element
CREATE TABLE public.element_miriam
(
  element_id integer NOT NULL,
  miriam_id integer NOT NULL,
  CONSTRAINT element_miriam_pkey PRIMARY KEY (element_id, miriam_id),
  CONSTRAINT element_miriam_element_fk FOREIGN KEY (element_id)
      REFERENCES public.alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT element_miriam_miriam_fk FOREIGN KEY (miriam_id)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- migrate data
insert into element_miriam (miriam_id, element_id) select miriam_data_table.iddb, alias_table.iddb from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join miriam_data_table on species_table.iddb = miriam_data_table.element_iddb;

alter table miriam_data_table drop column element_iddb;

-- former symbol list
CREATE TABLE element_former_symbols_new
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  symbol character varying(255),
  CONSTRAINT element_former_symbols_pk PRIMARY KEY (iddb, idx),
  CONSTRAINT element_former_symbols_fk FOREIGN KEY (iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

insert into element_former_symbols_new (iddb, idx, symbol) 
select alias_table.iddb, element_former_symbols.idx, element_former_symbols.symbol from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join element_former_symbols on species_table.iddb = element_former_symbols.iddb;

drop table element_former_symbols;

---synonyms list
CREATE TABLE element_synonyms_new
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  synonym character varying(255),
  CONSTRAINT element_synonyms_pk PRIMARY KEY (iddb, idx),
  CONSTRAINT element_synonyms_fk FOREIGN KEY (iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

insert into element_synonyms_new (iddb, idx, synonym) 
select alias_table.iddb, element_synonyms.idx, element_synonyms.synonym from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join element_synonyms on species_table.iddb = element_synonyms.iddb;

drop table element_synonyms;

--- antisense rna regions
CREATE TABLE antisense_rna_region_table_new
(
  iddb integer NOT NULL DEFAULT nextval('antisense_rna_region_table_iddb_seq'::regclass),
  idantisensernaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  idspeciesdb integer,
  state integer,
  type integer,
  CONSTRAINT antisense_rna_region_table_pk PRIMARY KEY (iddb),
  CONSTRAINT antisense_rna_region_table_fk FOREIGN KEY (idspeciesdb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO antisense_rna_region_table_new ( idantisensernaregion, name, pos, size, idspeciesdb,state,type) 
select antisense_rna_region_table.idantisensernaregion, antisense_rna_region_table.name, antisense_rna_region_table.pos, antisense_rna_region_table.size, alias_table.iddb, antisense_rna_region_table.state, antisense_rna_region_table.type from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join antisense_rna_region_table on species_table.iddb = antisense_rna_region_table.idspeciesdb;

drop table antisense_rna_region_table;

-- rna
-- modification residues
CREATE SEQUENCE rna_region_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE rna_region_table_new
(
  iddb integer NOT NULL DEFAULT nextval('rna_region_table_iddb_seq'::regclass),
  idrnaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  idspeciesdb integer,
  state integer,
  type character varying(255),
  CONSTRAINT rna_region_table_pk PRIMARY KEY (iddb),
  CONSTRAINT rna_region_table_fk FOREIGN KEY (idspeciesdb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO rna_region_table_new ( idrnaregion, name, pos, size, idspeciesdb,state) 
select rna_region_table.idrnaregion, rna_region_table.name, rna_region_table.pos, rna_region_table.size, alias_table.iddb, rna_region_table.state from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join rna_region_table on species_table.iddb = rna_region_table.idspeciesdb;

drop table rna_region_table;
drop sequence rna_region_table_idrnaregiondb_seq;


-- UPDATE 10.0.3/fix_db_20161003.sql

-- data mining
CREATE SEQUENCE datamining_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE datamining_table
(
  iddb integer NOT NULL DEFAULT nextval('datamining_table_iddb_seq'::regclass),
  old_idbb integer,
  description text,
  type integer,
  element_iddb integer NOT NULL,
  CONSTRAINT missingconnection_pk PRIMARY KEY (iddb),
  CONSTRAINT missingconnection_fk FOREIGN KEY (element_iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_table ( old_idbb, description, type, element_iddb) 
select datamining.iddb, datamining.description, datamining.type, alias_table.iddb as element_iddb from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join datamining on species_table.iddb = datamining.element_iddb;

CREATE TABLE datamining_references
(
  idx integer NOT NULL,
  datamining_iddb integer NOT NULL,
  references_iddb integer NOT NULL,
  CONSTRAINT datamining_references_pk PRIMARY KEY (datamining_iddb, idx),
  CONSTRAINT datamining_references_fk_data_mining FOREIGN KEY (datamining_iddb)
      REFERENCES datamining_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_references_fk_miriam FOREIGN KEY (references_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_references ( idx, datamining_iddb, references_iddb) 
select datamining_miriam_data_table.idx, datamining_table.iddb, datamining_miriam_data_table.references_iddb from datamining_table inner join datamining_miriam_data_table on datamining_table.old_idbb = datamining_miriam_data_table.datamining_iddb ;

drop table datamining_miriam_data_table;
alter table datamining_references rename column datamining_iddb  to datamining_table_iddb ;


drop table if exists datamining_connections;
CREATE TABLE datamining_connections
(
  idx integer NOT NULL,
  datamining_table_iddb integer NOT NULL,
  suggestedconnections_iddb integer NOT NULL,
  CONSTRAINT datamining_connections_pk PRIMARY KEY (datamining_table_iddb, idx),
  CONSTRAINT datamining_connections_fk_data_mining FOREIGN KEY (datamining_table_iddb)
      REFERENCES datamining_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_connections_fk_miriam FOREIGN KEY (suggestedconnections_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_connections ( idx, datamining_table_iddb, suggestedconnections_iddb) 
select datamining_suggested_connections.idx, datamining_table.iddb, datamining_suggested_connections.suggestedconnections_iddb from datamining_table inner join datamining_suggested_connections on datamining_table.old_idbb = datamining_suggested_connections.datamining_iddb ;

drop table datamining_suggested_connections;

alter table datamining_table drop column old_idbb;

drop table datamining;

drop table associated_phenotype_element_table;

drop table external_project;
drop table external_user;

-- clean info about annotations
delete from class_annotator_annotators_table  ;
delete from class_annotator_table  ;
delete from class_required_annotation_miriam_type_table  ;
delete from class_required_annotation_table  ;
delete from class_valid_annotation_miriam_type_table  ;
delete from class_valid_annotation_table  ;
update user_table  set annotationschema_iddb =null;
delete from user_annotation_schema_table;


-- UPDATE 10.0.3/fix_db_20161004.sql

-- drop old species implementation

alter table node_table drop column element_iddb;
alter table alias_table drop column idelementdb;
drop table species_table;

alter table alias_table rename column aliasid to elementid;


-- UPDATE 10.0.3/fix_db_20161005.sql

alter table submodel_connection_table rename fromalias_iddb to fromelement_iddb;
alter table submodel_connection_table rename toalias_iddb to toelement_iddb;

alter table alias_table rename to element_table;

update element_table set alias_type_db ='Bottom square Compartment' where alias_type_db = 'Bottom square Compartment Alias';
update element_table set alias_type_db ='Left square Compartment' where alias_type_db = 'Left square Compartment Alias';
update element_table set alias_type_db ='Oval Compartment' where alias_type_db = 'Oval Compartment Alias';
update element_table set alias_type_db ='Compartment' where alias_type_db = 'Compartment Alias';
update element_table set alias_type_db ='Pathway Compartment' where alias_type_db = 'Artifitial Compartment Alias';
update element_table set alias_type_db ='Right square Compartment' where alias_type_db = 'Right square Compartment Alias';
update element_table set alias_type_db ='Square Compartment' where alias_type_db = 'Square Compartment Alias';
update element_table set alias_type_db ='Top square Compartment' where alias_type_db = 'Top square Compartment Alias';

alter table node_table drop column element_iddb;
alter table node_table rename alias_iddb to element_iddb;

update element_table set alias_type_db ='Complex' where alias_type_db = 'Complex Species Alias';
update element_table set alias_type_db ='Species' where alias_type_db = 'Species Alias';

alter table element_table rename alias_type_db  to element_type_db;
alter table element_table  rename idcomplexaliasdb to idcomplexdb;

alter table element_table  rename aliasstatelabel to statelabel;
alter table element_table  rename aliasstateprefix to stateprefix;


-- UPDATE 10.0.3/fix_db_20161006.sql

alter table element_table  rename compartmentalias_iddb to compartment_iddb;


-- UPDATE 10.0.3/fix_db_20161007.sql

update element_table set idcomplexdb=parent_iddb where idcomplexdb is null and parent_iddb is not null and parent_iddb in (select iddb from element_table where element_type_db= 'Complex');

update element_table set compartment_iddb = parent_iddb where compartment_iddb is null and parent_iddb is not null and parent_iddb in (select iddb from element_table where element_type_db<> 'Complex');

alter table element_table  drop COLUMN parent_iddb ;

alter SEQUENCE alias_table_iddb_seq rename to element_table_iddb_seq;

drop sequence associated_phenotype_element_table_iddb_seq;

drop sequence layout_iddb_seq;

alter sequence layout_iddb_seq1 rename to layout_iddb_seq;

drop sequence search_index_table_iddb_seq;

alter sequence search_index_table_iddb_seq1 rename to search_index_table_iddb_seq;

alter table antisense_rna_region_table_new RENAME to antisense_rna_region_table;
alter table element_former_symbols_new rename to element_former_symbols;
alter table element_synonyms_new rename to element_synonyms;
alter table modification_residue_table_new rename to modification_residue_table;
alter table rna_region_table_new rename to rna_region_table;


-- UPDATE 10.0.3/fix_db_20161010.sql

DROP TABLE IF EXISTS layerline;

update  miriam_data_table set datatype='MI_R_BASE_SEQUENCE' where datatype  ='MI_RBASE_SEQUENCE';


-- UPDATE 10.0.3/fix_db_20161012.sql

alter table user_table add column maxcolor bytea;
alter table user_table add column mincolor bytea;


-- UPDATE 10.0.3/fix_db_20161026.sql

--merging project and model logs
alter table project_table add column warnings text;
update project_table set warnings = (select creationwarnings from model_table  where project_iddb = project_table.iddb);

alter table model_table drop column creationwarnings;


-- UPDATE 10.0.3/fix_db_20161027.sql

--sbgn format moved from model into project
alter table project_table add column sbgnformat boolean default false ;
update project_table set sbgnformat = (select sbgnformat from model_table  where project_iddb = project_table.iddb);

alter table model_table drop column sbgnformat;

--PrivilegeType should be mapped in database by name not by index
alter table privilege_table add column type_string character varying;
update privilege_table set type_string = 'VIEW_PROJECT' where type = 0;
update privilege_table set type_string = 'ADD_MAP' where type = 1;
update privilege_table set type_string = 'EDIT_MISSING_CONNECTIONS_PROJECT' where type = 2;
update privilege_table set type_string = 'EDIT_COMMENTS_PROJECT' where type = 3;
update privilege_table set type_string = 'DRUG_TARGETING_ADVANCED_VIEW_PROJECT' where type = 4;
update privilege_table set type_string = 'PROJECT_MANAGEMENT' where type = 5;
update privilege_table set type_string = 'USER_MANAGEMENT' where type = 6;
update privilege_table set type_string = 'CUSTOM_LAYOUTS' where type = 7;
update privilege_table set type_string = 'LAYOUT_VIEW' where type = 8;
update privilege_table set type_string = 'CONFIGURATION_MANAGE' where type = 9;
update privilege_table set type_string = 'LAYOUT_MANAGEMENT' where type = 10;
update privilege_table set type_string = 'MANAGE_GENOMES' where type = 11;
alter table privilege_table drop column type;
alter table privilege_table rename type_string   TO type;


-- UPDATE 10.0.4/fix_db_20161215.sql

-- fix on comment visibility in new version
update feedback set tablename = 'lcsb.mapviewer.model.map.species.Species' where tablename='lcsb.mapviewer.model.map.layout.alias.SpeciesAlias';
update feedback set tablename = 'lcsb.mapviewer.model.map.species.Complex' where tablename='lcsb.mapviewer.model.map.layout.alias.ComplexAlias';

-- UPDATE 10.0.4/fix_db_20161228.sql

-- fix on drugbank parser
delete from cachequery where query like 'drug:%' and type in (select iddb from cache_type  where classname ='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');
delete from cachequery where query like 'http:%' and type in (select iddb from cache_type  where classname ='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');


-- UPDATE 10.0.5/fix_db_20170131.sql

-- empty file to force directory to be commited to git repo
